/* Copyright (C) 1998 Odysseas Pentakalos and Aram Khalili

  This program is freely distributable under the GNU General
  Public License Version 2 or later. The GNU GPL is available
  from the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307, USA.

  The authors can be contacted by email :
  Odysseas Pentakalos : odysseas@cs.umbc.edu
  Aram Khalili        : akhali1@gl.umbc.edu
*/

#ifndef _EXABYTE210_H_
#define _EXABYTE210_H_

#include <sys/types.h>

#define ELEMENT_STATUS_DATA 8
#define ELEMENT_STATUS_PAGE 8
#define ELEMENT_GROUPS 1
#define MEDIUM_TRANSPORT_ELEMENT 16
#define STORAGE_ELEMENT 16
#define DATA_TRANSFER_ELEMENT 16

#define NUM_MEDIUM_TRANSPORT       0
#define NUM_STORAGE_ELEMENT       11 
#define NUM_DATA_TRANSFER_ELEMENT  0

#define NUM_ELEMENTS              11

typedef struct {
  u_int first_element;
  u_int num_element;
  u_int elem_status_page_bytes;
} Elem_Status_Data_t;

typedef struct {
  u_int elem_type;
  u_char pvoltag_flag;
  u_int elem_desc_len;
  u_int elem_desc_len_tot;
} Elem_Status_Page_t;

typedef struct {
  u_int elem_addr;
  u_char access;
  u_char except;
  u_char full;
  u_char add_sense;
  u_char add_sense_qual;
  u_char svalid;
  u_char invert;
  u_int  source_elem_addr;
} Storage_Element_Desc_t;

typedef struct {
  u_int elem_addr;
  u_char access;
  u_char except;
  u_char full;
  u_char add_sense;
  u_char add_sense_qual;
  u_char idvalid;
  u_char luvalid;
  u_char lun;
  u_char scsi_addr;
  u_char svalid;
  u_char invert;
  u_int  source_elem_addr;
} Data_Transfer_Element_Desc_t;

typedef struct {
  u_int elem_addr;
  u_char except;
  u_char full;
  u_char add_sense;
  u_char add_sense_qual;
  u_char svalid;
  u_char invert;
  u_int  source_elem_addr;
} Medium_Transport_Element_Desc_t;

u_int medium_transport_element_address=86;

#endif _EXABYTE210_H_
