/* Copyright (C) 1998 Odysseas Pentakalos and Aram Khalili

  This program is freely distributable under the GNU General
  Public License Version 2 or later. The GNU GPL is available
  from the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307, USA.

  The authors can be contacted by email :
  Odysseas Pentakalos : odysseas@cs.umbc.edu
  Aram Khalili        : akhali1@gl.umbc.edu
*/

#include <stdio.h>
#include <string.h>
#include <scsi/sg.h>
#include <scsi/scsi.h>
#include <sys/types.h>
#include "tapelib.h"

int init_elt_stat(int fd, __u16 nbl)
{
  typedef struct {
    struct sg_header head;
    u_char cmd[6];
  } SCSI_Cmd_t;

  SCSI_Cmd_t Cmd;
  int i, ret;

  for (i=0; i<6; i++)
    Cmd.cmd[i]=0;

  Cmd.cmd[0]=0x07; /* set command */
  Cmd.cmd[1]=0x00; /* LUN = 0, reserved = 0 */
  Cmd.cmd[2]=0x00; /* reserved */
  Cmd.cmd[3]=0x00; /* reserved */
  Cmd.cmd[4]=0x00; /* reserved */
  Cmd.cmd[5]=nbl?128:0; /* nbl (bit 8) = nbl */

  Cmd.head.pack_len=sizeof(Cmd);
  Cmd.head.reply_len=sizeof(Cmd);
  Cmd.head.pack_id=1;

#ifdef DEBUG
  printf("init_elt_status: Sending out the INIT ELEMENT STATUS command\n");
  printf("init_elt_status: using nbl = %d\n", nbl);
#endif DEBUG

  ret=write(fd, &Cmd, sizeof(Cmd));

#ifdef DEBUG
  printf("init_elt_stat: The write returned %d status\n", ret);
#endif DEBUG

  /*
    Now lets read back the results
    */
  ret=read(fd, &Cmd, sizeof(Cmd));

#ifdef DEBUG
  printf("init_elt_stat: The read returned %d bytes\n", ret);
#endif DEBUG

  return ret;

}













