/* Copyright (C) 1998 Odysseas Pentakalos and Aram Khalili

  This program is freely distributable under the GNU General
  Public License Version 2 or later. The GNU GPL is available
  from the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307, USA.

  The authors can be contacted by email :
  Odysseas Pentakalos : odysseas@cs.umbc.edu
  Aram Khalili        : akhali1@gl.umbc.edu
*/

#include <stdio.h>
#include <string.h>
#include <scsi/sg.h>
#include <scsi/scsi.h>
#include <sys/types.h>
#include "tapelib.h"

int position_elt(int fd, __u16 tea, __u16 dest)
{
  typedef struct {
    struct sg_header head;
    u_char cmd[10];
  } SCSI_Cmd_t;

  SCSI_Cmd_t Cmd;
  int i, ret;

  for (i=0; i<10; i++)
    Cmd.cmd[i]=0;


  Cmd.cmd[0]=POSITION_TO_ELEMENT;
  Cmd.cmd[1]=0x00;

  /* 
     Transport element address that will perform the move operation
     */
  Cmd.cmd[2]=(tea & 0xff00) >> 8;
  Cmd.cmd[3]=tea & 0x00ff;

  /*
    Destination element address to where cartridge will be taken
    */
  Cmd.cmd[4]=(dest & 0xff00) >> 8;
  Cmd.cmd[5]=dest & 0x00ff;

  /*
    Reserved bytes should all be zero-ed
    */
  Cmd.cmd[6]=0;
  Cmd.cmd[7]=0;
  Cmd.cmd[8]=0;
  Cmd.cmd[9]=0;

  /*
    Prepare the header
    */
  Cmd.head.pack_len=sizeof(Cmd);
  Cmd.head.reply_len=sizeof(Cmd);
  Cmd.head.pack_id=1;

#ifdef DEBUG
  printf("position_elt: Sending out the POSITION_TO_ELEMENT command\n");
  printf("position_elt: using transport element %d to go to %d\n",
	 tea, dest);
#endif DEBUG

  ret=write(fd, &Cmd, sizeof(Cmd));

#ifdef DEBUG
  printf("position_elt: The write returned %d status\n", ret);
#endif DEBUG

  /*
    Now lets read back the results
    */
  ret=read(fd, &Cmd, sizeof(Cmd));

#ifdef DEBUG
  printf("position_elt: The read returned %d bytes\n", ret);
#endif DEBUG

  return ret;

}













