/* Copyright (C) 1998 Odysseas Pentakalos and Aram Khalili

  This program is freely distributable under the GNU General
  Public License Version 2 or later. The GNU GPL is available
  from the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307, USA.

  The authors can be contacted by email :
  Odysseas Pentakalos : odysseas@cs.umbc.edu
  Aram Khalili        : akhali1@gl.umbc.edu
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include "tapelib.h"

main(int argc, char *argv[])
{
  int i, fd, fd2;

  if (argc < 3) {
    fprintf(stderr, "%s dev src dest\n", argv[0]);
    exit(1);
  }

  if ((fd=open(argv[1], O_RDWR | O_EXCL)) == -1) {
    fprintf(stderr, "%s: could not open %s in O_RDWR | O_EXCL mode\n",
	    argv[0], argv[1]);
    exit(1);
  }

  if ((fd2=open(argv[2], O_RDWR | O_EXCL)) == -1) {
    fprintf(stderr, "%s: could not open %s in O_RDWR | O_EXCL mode\n",
	    argv[0], argv[2]);
    exit(1);
  }

  for (i=1; i <= 10; i++) {
    move_medium(fd, (__u32) atoi("86"), (__u32) atoi("82"), (__u32) i);
    
    move_medium(fd, (__u32) atoi("86"), (__u32) i, (__u32) atoi("82"));

    load(fd2, 1);

    load(fd2, 0);

  }

  exit(0);

}
